Wine industry calls for government investment
It might sound like a good problem to have - a glut of wine sloshing around local barrels.
But a decline in export markets and changes in consumer behaviour have left some grape growers ripping up their vines and exiting the industry altogether.
In the latest development - one of Australia’s largest wineries - Winemasters SA - has appointed administrators following a failed sales bid.
GUEST: Lee McLean, … ⌘ Read more
Australian bush tea hits shelves in Asia
The product is being sent from a remote property in the Northern Territory all the way to Japan, Korea and China. ⌘ Read more
Bargain avocados in high demand but growers pay price
A bumper avocado season is creating a perfect storm for cheaper produce and record export volumes, but growers are doing it tough. ⌘ Read more
New cold storage facility to streamline supply chains for citrus growers
Oranges, mandarins, lemons and table grapes could soon have a more direct path to market. ⌘ Read more
Sobering export report for Australian producers as world turns off wine consumption
Global demand for Australian wine is continuing to dwindle, with the latest Wine Australia export report showing an 8 per cent decrease in 2025 as consumers opt for alcohol-free trends. ⌘ Read more
Aussie table grape exports jump nearly 300 per cent amid ‘great’ growing year
A rise in demand is making it feasible for some Australian grapes to be on sale in South-East Asia within 48 hours of being dispatched. ⌘ Read more
China suspends ban on exports of gallium, germanium, antimony to U.S. ⌘ Read more
Russia’s Oil Exports Plunge to Lowest Level in Months After US Sanctions ⌘ Read more
Ukraine to set up arms export offices in Berlin, Copenhagen, Zelenskiy says ⌘ Read more
Russia’s Oil Exports to India Face Collapse After New US Sanctions ⌘ Read more
Sweden signs letter of intent to export 100-150 Gripen fighter jets to Ukraine ⌘ Read more
Russia’s Oil Exports Declines by 17.1% After Massive Drone Strikes Hit Key Refineries ⌘ Read more
Terres rares : la Chine verrouille, Trump riposte, l’Europe paie
Coup de tonnerre sur le commerce mondial : les Chinois, d’habitude prudents, commerçants et cherchant le compromis, décident d’imposer de nouveaux contrôles drastiques à l’exportation de leurs terres rares, y compris raffinées et utilisées dans les technologies modernes. Ainsi, dans une annonce récente du ministère chinois du Commerce datée du 9 octobre 2025, on apprend que […] ⌘ Read more
Trump puts extra 100% tariff on China imports, adds export controls on ‘critical software’ ⌘ Read more
Trump threatens to pull out of planned Xi meeting
Trump also threatened a “massive” tariff increase, after China tightened its rules for exports of rare earths. ⌘ Read more
Trump threatens to pull out of planned Xi meeting
Trump also threatened a “massive” tariff increase, after China tightened its rules for exports of rare earths. ⌘ Read more
Trump threatens to pull out of planned Xi meeting
Trump also threatened a “massive” tariff increase, after the country tightened its rules for exports of rare earths. ⌘ Read more
Trump threatens to pull out of planned Xi meeting
Trump also threatened a “massive” tariff increase, after the country tightened its rules for exports of rare earths. ⌘ Read more
Security updates for Thursday
Security updates have been issued by AlmaLinux (gnutls, kernel, kernel-rt, and open-vm-tools), Debian (chromium, python-django, and redis), Fedora (chromium, insight, mirrorlist-server, oci-seccomp-bpf-hook, rust-maxminddb, rust-prometheus, rust-prometheus_exporter, rust-protobuf, rust-protobuf-codegen, rust-protobuf-parse, rust-protobuf-support, turbo-attack, and yarnpkg), Oracle (iputils, kernel, open-vm-tools, redis, and valkey), Red Hat (perl-File-Find-Rule and perl-File-Find-Rul … ⌘ Read more
China tightens export rules for crucial rare earths
Beijing’s monopoly over rare earths is a key bargaining chip in its trade negotiations with the US. ⌘ Read more
China tightens export rules for crucial rare earths
The announcement comes ahead of a meeting between China’s President Xi Jinping and his US counterpart Donald Trump later this month. ⌘ Read more
China tightens export rules for crucial rare earths
The announcement comes ahead of a meeting between China’s President Xi Jinping and his US counterpart Donald Trump later this month. ⌘ Read more
China tightens export rules for crucial rare earths
The announcement comes ahead of a meeting between China’s President Xi Jinping and his US counterpart Donald Trump later this month. ⌘ Read more
Exporte im Juli um 11,9 Prozent eingebrochen ⌘ Read more
index.md a prehook and a few utilities:
@bender@twtxt.net Yes I did about a week or so ago. It took me a lot of effort to get the content even rendered in the first place. LOL I had to basically export my blog as HTML (can you believe that?!) – The Hugo export just didn’t work at all 🤣
Aussie apple exports to Canada easier as restrictions relaxed
Australia apple growers will have easier access to the Canadian export market following trade negotiations between the nations. ⌘ Read more
Trouble exporting P3D via PGraphics recording (OpenGL error 1282) :blobcatsad:
@lyse@lyse.isobeef.org @kat@yarn.girlonthemoon.xyz Colorized manpages have been a thing for a very long time:
Problem is, hardly anybody knows this, because you configure this by … drumroll … overwriting TERMCAP entries of less in your ~/.bashrc:
export LESS_TERMCAP_md=$'\e[38;5;3m' # Bold
export LESS_TERMCAP_me=$'\e[0m' # End Bold
export LESS_TERMCAP_us=$'\e[4;38;5;6m' # Underline
export LESS_TERMCAP_ue=$'\e[0m' # End Underline
export GROFF_NO_SGR=1 # Needed since groff 1.23
As in regards to technology…
“Behind the scenes, U.S. Trade Representative Jamieson Greer and EU’s Maroš Šefčovič hashed out technical annexes on automobiles, pharmaceuticals and digital trade.”
“Tech giants Microsoft’s cloud services, Apple’s iPhones and Google’s data solutions gain tariff-free pathway, fueling digital exports growth.”
“Digital Services: Microsoft announces a new 150 MW cloud data center in Berlin backed by tariff-free equipment imports; SAP commits to expanding U.S. R&D hubs in Austin, Texas.”
Court downplays scale of cattle industry losses after live export ban
Hundreds of claimants seeking compensation are considering an appeal, after the federal court found the 2011 live export ban did not impact export quotas “in any material way”. ⌘ Read more
China stellt Lockerungen in Aussicht
Im Streit um den Export von Seltenerdmetallen hat China der EU angeboten, Anträge europäischer Firmen schneller zu bearbeiten. Auch gegenüber US-Autoherstellern soll China seine Haltung gelockert haben. Die EU-Handelskammer berichtete von leichten Verbesserungen bei den Ausfuhrgenehmigungen. ⌘ Read more
Australia could bargain over partial US beef ban in Trump tariff talks
A government source says beef is being positioned as a bargaining chip to help reset trade ties after the US imposed harsh tariffs on Australian exports. ⌘ Read more
Exportstopp: Mangel an Seltenen Erden könnte erste Auswirkungen zeigen
Seit zwei Monaten sind die Exporte von sieben wichtigen Elementen aus China nahezu gestoppt. Nun mehren sich die Warnungen vor Folgen, aber nicht überall. ( Seltene Erden, Akku)
US-China-Handelskrieg trifft EU-Autobauer
Autozulieferer in Europa haben dem Branchenverband CLEPA zufolge mit Knappheit bei Seltenerdmetallen zu kämpfen. Die ersten Fertigungslinien hätten bereits gestoppt werden müssen, teilte der Branchenverband am Mittwoch mit. China hatte den Export von Seltenerdmetalle im Rahmen des Handelskrieges mit den USA eingeschränkt – und Europas Industrie kommt nun zwischen die Fronten. ⌘ Read more
Trump raises steel, aluminum tariffs to 50%, hitting key Ukrainian export ⌘ Read more
Russian national charged in Toronto with illegally exporting military goods to Russia ⌘ Read more
Citrus producers hopeful for bumper harvest after tough seasons
Citrus growers are looking forward to a bountiful season in 2025, with hopes it could even become a record-breaking export year. ⌘ Read more
WA prides itself on resources and agriculture, but what role can the humble apple play?
The success of a unique variety of West Australian apple that in three years has become the state’s biggest apple export, could pave the way for further varieties to hit supermarket shelves. ⌘ Read more
$10,000 Bounty: HackerOne Report Comments Leak via “Export as .zip”
How a new export feature unintentionally exposed private discussions in limited disclosure reports
[Continue reading on InfoSec Write-ups »](https://infose … ⌘ Read more
Australian wine exports on the slide as world drinks less
Australian wine began flowing back into China last year after tariffs were removed, but the country’s wine exports more broadly are declining significantly. ⌘ Read more
Apples grown on Aussie mainland to be exported to China for first time
An agreement being reached on fruit fly protocols means apples from the Australian mainland can now be exported to China. ⌘ Read more
China plans to build a nuclear power plant on the Moon + 2 more stories
China urges Korea to restrict rare earth exports to U.S.; global coral bleaching spreads due to record ocean heat; China plans a nuclear power plant on the Moon. ⌘ Read more
Security updates for Tuesday
Security updates have been issued by AlmaLinux (java-1.8.0-openjdk, kernel, libxslt, mod_auth_openidc:2.3, and webkit2gtk3), Fedora (c-ares, giflib, jupyterlab, perl, perl-Devel-Cover, perl-PAR-Packer, prometheus-podman-exporter, python-notebook, python-pydantic-core, rpki-client, ruby, rust-adblock, rust-cookie_store, rust-gitui, rust-gstreamer, rust-icu_collections, rust-icu_locid, rust-icu_locid_transform, rust-icu_locid_transform_data, rust-icu_normalizer, rust-icu_normalizer_data … ⌘ Read more
Security updates for Monday
Security updates have been issued by Debian (erlang, fig2dev, shadow, wget, and zabbix), Fedora (chromium, jupyterlab, llama-cpp, prometheus-podman-exporter, python-notebook, python-pydantic-core, rpki-client, rust-adblock, rust-cookie_store, rust-gitui, rust-gstreamer, rust-icu_collections, rust-icu_locid, rust-icu_locid_transform, rust-icu_locid_transform_data, rust-icu_normalizer, rust-icu_normalizer_data, rust-icu_properties, rust-icu_properties_data, rust-icu_provider, rust-icu\ … ⌘ Read more
“Move to iOS” app continuously refused to run as intended and expected, so couldn’t migrate mum’s Android based phone data. Most of her stuff is on a Google account, but not the SMS/MMS/RCS messages. Haven’t found a way to export, then import those into iOS.
She isn’t too happy having to keep the old phone just for the messages. Need to find a way to go through them, export multimedia attachments, and import them into iOS. I don’t think it’s going to happen, but I am not letting her know yet. 😅
@prologic@twtxt.net Gemini has an answer for you:
This is a conversation thread from a twtxt network, detailing a user’s (movq) frustration with the Mastodon “export data” feature and their consideration of self-hosting a fediverse alternative. Here’s a summary:
- movq’s initial issue:
- movq is concerned about the volatility of their data on their current Mastodon instance due to a broken “export data” feature.
- They contacted the admins, but the issue remains unresolved.
- This led them to contemplate self-hosting.
- movq is concerned about the volatility of their data on their current Mastodon instance due to a broken “export data” feature.
- Alternative fediverse software suggestions:
- kat suggests gotosocial as a lightweight alternative to Mastodon.
- movq agrees, and also mentions snac as a potential option.
- kat suggests gotosocial as a lightweight alternative to Mastodon.
- movq’s change of heart:
- movq ultimately decides that self-hosting any fediverse software, besides twtxt, is too much effort.
- movq ultimately decides that self-hosting any fediverse software, besides twtxt, is too much effort.
- Resolution and compromise:
- The Mastodon admins attribute the export failure to the size of movq’s account.
- movq decides to set their Mastodon account to auto-delete posts after approximately 180 days to manage data size.
- Movq also mentions that they use auto-expiring links on twtxt to reduce data storage.
- The Mastodon admins attribute the export failure to the size of movq’s account.
The Mastodon admins say that it’s probably because of the size of my account (~600 MB), so the export process times out. And I understand that. Here on twtxt, I always use auto-expiring links when I post images or videos. It just gets too much data otherwise. I think I’ll just set my Mastodon account to auto-delete posts after ~180 days or something like that. Nobody cares about old posts anyway.
Extending my Komoot export script
I’ve taken another look at my export script for Komoot (original post), now that Bending Spoons has acquired Komoot. I’ve extended the script to also download cover images and, if available, an image of the map – I found that in the API responses. ⌘ Read more
如何使用 go:linkname 指令訪問 Go 包中的私有函數
在 Go 語言的包設計中,函數和變量通過首字母大小寫來嚴格區分導出(exported)與未導出(unexported)的可見性規則。這種機制是 Go 模塊化設計的基石,但同時也爲底層系統級開發帶來了限制。//go:linkname 指令正是 Go 爲突破這一限制預留的「後門」,它通過編譯器的符號重定向能力,允許開發者直接鏈接任意包的未導出符號——無論是標準庫的私有函數,還是第三方包的隱藏變量。本文 ⌘ Read more
I think I should try self-hosting some Mastodon thingy again.
The “export data” feature on the Mastodon instance I’m using seems to be broken. I’ve contacted the admins but we couldn’t find the issue – yet. I don’t want to bother them too much, it’s a free service after all.
But this means that everything I post over there is very, very volatile. It could all be gone in 5 minutes and I’ll have no way to restore it. Hmm.
Ontario Threatens to Cut Off U.S. Energy Exports If Trump Makes Good on Tariff Plan
Janna Brancolin, Staff Writer - msn | The Daily Beast
Stephan: I think the U.S. economy will be devastated if the stupidity of Trump’s tariff plan is enacted. Here is an aspect of the Canadian response that neither Trump nor his congressional submissive seems to have even considered.
 found a bug or security hole in GoBlog or b) actually sent well over 5 million requests to my site to like my post about how to export GPX files automatically from Komoot? 🤔 ⌘ Read more
Gain insights into cloud native applications with the OpenTelemetry Certified Associate (OTCA)
Announcing a New CNCF certification for OpenTelemetry OpenTelemetry (also known as OTel) is an open-source observability framework with tools, libraries, APIs, and SDKs for collecting, processing, and exporting rich telemetry data such as traces, metrics, and… ⌘ Read more
International retailers fly into WA to learn more about avocados as export demand grows
Last financial year Western Australia produced a record volume of more than 65,000 tonnes of avocados, representing 44 per cent of the total volume grown in Australia. ⌘ Read more
Docker Desktop 4.35: Organization Access Tokens, Docker Home, Volumes Export, and Terminal in Docker Desktop
Docker Desktop 4.35 includes organization access tokens, a new Docker product home page, terminal enhancements, Docker Desktop for Red Hat Enterprise Linux, and the performance boost from Docker VMM for Apple Silicon Macs. ⌘ Read more
monerod-gui v0.1.2-rc released with Windows installer and portable app
everoddandeven1 has released monerod-gui 2 version 0.1.2-rc3 with a new Windows installer and portable app, multiple fixes and improvements:
Changes overviewThis tool simplifies the process of managing a full Monero node, enabling users to run, configure, and monitor monerod without needing to use the command line.
Import/export monerod configuration
Windows portable app and installer
... ⌘ [Read more](https://monero.observer/everoddandeven-releases-monerod-gui-v0.1.2-rc/)
Farmers race to get chickpeas from Australian paddocks to India as tariff deadline looms
Pressure is mounting to get Australia’s chickpea harvest into India before taxes that could cost exporters more than half their profit kick back in. ⌘ Read more
woodser releases Haveno v1.0.12 with various fixes and improvements
woodser1 has released Haveno2 version 1.0.123 with various improvements, updates, and bug fixes.
Update to monero-project v0.18.3.4 and monero-java v0.8.33
Play sounds for notifications (can be disabled in Settings)
Schedule offers using available and pending funds
Support AppImage installer for Linux
Fix exporting and importing payment accounts across clients
Reclassify mainnet nodes as pub ... ⌘ [Read more](https://monero.observer/woodser-releases-haveno-v1.0.12/)
PEP 756: Add PyUnicode_Export() and PyUnicode_Import() C functions
Add functions to the limited C API version 3.14: ⌘ Read more
Automatic Komoot export
While I like Komoot and use it to navigate and record all my tours, whether that are bike tours or hiking trips, it sucks that there’s no option to export all your data. There’s also no official API to easily implement such functionality. ⌘ Read more
Pineapple is an iconic Australian fruit but its undersupplied market may be ripe for imports
The federal government is undertaking a biosecurity risk assessment after India and Indonesia applied to export pineapples to Australia under their free trade deals. ⌘ Read more
India goes for ‘green gold’ as Australian avocados grow in popularity in massive new export market
From Melbourne to Mumbai, demand for avocado is on the rise in India, creating a big opportunity for Australian farmers who might otherwise dump fruit due to oversupply. ⌘ Read more
Adding more context to my blogroll
The hosted Miniflux finally contains my newly contributed feature to save descriptions for feeds. The exported OPML also contains them, and that’s why I’m finally able to show some context on my blogroll. ⌘ Read more
‘Great Friday’ for winemakers ready to ‘instantly’ resume shipments of China-bound drops
While wine authorities say getting Australian exports to China back to pre-tariff levels could be “a matter of years”, many in the industry are not only rejoicing, but getting set to resume shipments. ⌘ Read more
Bitter news for wine exporters as more people choose not to drink to save money — and health
Australian wine exports have been hit by a global trend in people drinking less alcohol and cutting costs, but hope remains for the re-opening of a major market. ⌘ Read more
Queensland farmer specialises in melons that you’re unlikely to see on supermarket shelves
Shaun Jackson grows niche varieties of melons and, just as Australians are cutting back on fruit, an expanding Japanese market can’t get enough of them. ⌘ Read more
New jumbo blueberry varieties behind farm’s big expansion plans
The biggest blueberries in the world are grown in Western Australia and export markets love them. Demand for the berries is driving one farm to quadruple in size. ⌘ Read more
Why funky young wines are a winner for Aussie producers looking for fresh export markets
It’s out with the heavy old-world styles and in with bright, natural drops as young consumers around the globe seek wines with more Australian sunshine and fewer additives. ⌘ Read more
China wine tariff review ‘no silver bullet’, but Australian producers hold hope for the future
Wine exports to China have dropped to a low of $10 million a year, but China’s announcement it will review tariffs on imports has given a glimmer of hope to the industry. ⌘ Read more
Apple farmers exit industry after pocketing a rise of just 50c a kilo in 20 years
Retail fruit prices have barely changed in two decades, exports have dropped to around two per cent of the nation’s crop and producers are fleeing the industry, new data from a NSW Farmers Association survey reveals. ⌘ Read more
Updated China-Australia trade list welcomed by citrus industry
Australia’s citrus industry welcomes an administrative milestone, the publication of a new list of orchards, packhouses and treatment facilities allowed to export to China. ⌘ Read more
Grape growers eye off diverse new markets for export
Wine exporters across regional Victoria are building stronger ties with overseas countries to offload a glut of red wine, in what is being described as one of the most challenging harvests the sector has ever seen. ⌘ Read more
Just finished writing my doc on how I’m using Parabola to export LJ to Plume https://ouvaton.link/F0KxT5
Wineries eye further opportunities in US as producers continue to feel the squeeze from China tariffs
More than two years after China placed tariffs on Australian wine, SA producers are still looking for alternative markets for their product. ⌘ Read more
How to create a keyboard shortcut to export the current slide in Keynote
Lately I’ve been using Apple Keynote to create graphics for using in videos and blog posts. It’s a quick way to arrange things on a page, copying and pasting most things just works, and there are enough built in shapes and tools to get the point across. However, after spending a full day creating graphics for a video, I found myself frustrated by the number of clicks required to export a single slide at a time. ⌘ Read more
Announcing Docker Hub Export Members
Find out how Docker Business admins can export members to track their utilization of Docker and audit Docker usage. ⌘ Read more
Scan QR codes right from your Linux Terminal
… you can export the QR codes as images… or even ASCII art! Neat! ⌘ Read more
Pakistan loves chai so much, it may need to export green tea to fund its addiction
Tea is deeply entrenched across gender and social classes in Pakistan, even as the country explores non-import alternatives like herbal and green tea. ⌘ Read more
How’s the China-India economic relationship changed 2 years on from the deadly Galwan Valley border clash?
China’s exports to India grew to US$27.1 billion in the first quarter of 2022, but India is concerned by its ballooning trade deficit with its neighbour amid strained ties two years after the deadly Galwan Valley clash. ⌘ Read more
China’s world’s factory tag threatened by Vietnam, but ‘there’s nothing to worry about’, analysts say
Vietnam’s first quarter exports reached US$88.58 billion, up by 12.9 per cent from the previous year, with Chinese state media comparing the shipments in the first three months of the year to China’s main export hub of Shenzhen. ⌘ Read more
Indonesia looks to Singapore to offload its surplus chickens
Indonesia produces 55 million to 60 million chickens per week and currently has a surplus. Singapore has been scrambling to find alternative supply sources since Malaysia restricted poultry exports. ⌘ Read more
EU seeks to release Ukrainian grain stuck due to Russia’s sea blockade
The EU supports efforts by the United Nations to broker a deal to resume Ukraine’s sea exports in return for easing Russian food and fertiliser exports, but that would need Moscow’s green light. ⌘ Read more
China’s latest hot export is a US$50 toy Russian fighter jet that ‘will never break’, helped by social media such as TikTok
The fighter jet toy, with a price tag of less than US$50 on e-commerce sites such as eBay and Amazon, has gained popularity for its affordability and durability. ⌘ Read more
China manufacturing: fresh lay-offs in the Pearl River Delta add to worries over economic slowdown
In the Pearl River Delta, factories are laying off workers and young people are struggling to find casual jobs as China’s export machine slows amid multiple headwinds. ⌘ Read more
US pressures Iran by targeting Hong Kong and UAE firms
Penalties over petrochemical exports were also imposed on Chinese citizen Jinfeng Gao and Indian national Mohammed Shaheed Ruknooddin Bhore. ⌘ Read more
How would a US recession impact Singapore, Malaysia, Thailand amid surging inflation?
If the US were to enter a recession, export-reliant Singapore and Malaysia would be among the worst hit, while remittances to the Philippines may decline, analysts say. ⌘ Read more
#!/bin/sh
# Validate environment
if ! command -v msgbus > /dev/null; then
printf "missing msgbus command. Use: go install git.mills.io/prologic/msgbus/cmd/msgbus@latest"
exit 1
fi
if ! command -v salty > /dev/null; then
printf "missing salty command. Use: go install go.mills.io/salty/cmd/salty@latest"
exit 1
fi
if ! command -v salty-keygen > /dev/null; then
printf "missing salty-keygen command. Use: go install go.mills.io/salty/cmd/salty-keygen@latest"
exit 1
fi
if [ -z "$SALTY_IDENTITY" ]; then
export SALTY_IDENTITY="$HOME/.config/salty/$USER.key"
fi
get_user () {
user=$(grep user: "$SALTY_IDENTITY" | awk '{print $3}')
if [ -z "$user" ]; then
user="$USER"
fi
echo "$user"
}
stream () {
if [ -z "$SALTY_IDENTITY" ]; then
echo "SALTY_IDENTITY not set"
exit 2
fi
jq -r '.payload' | base64 -d | salty -i "$SALTY_IDENTITY" -d
}
lookup () {
if [ $# -lt 1 ]; then
printf "Usage: %s nick@domain\n" "$(basename "$0")"
exit 1
fi
user="$1"
nick="$(echo "$user" | awk -F@ '{ print $1 }')"
domain="$(echo "$user" | awk -F@ '{ print $2 }')"
curl -qsSL "https://$domain/.well-known/salty/${nick}.json"
}
readmsgs () {
topic="$1"
if [ -z "$topic" ]; then
topic=$(get_user)
fi
export SALTY_IDENTITY="$HOME/.config/salty/$topic.key"
if [ ! -f "$SALTY_IDENTITY" ]; then
echo "identity file missing for user $topic" >&2
exit 1
fi
msgbus sub "$topic" "$0"
}
sendmsg () {
if [ $# -lt 2 ]; then
printf "Usage: %s nick@domain.tld <message>\n" "$(basename "$0")"
exit 0
fi
if [ -z "$SALTY_IDENTITY" ]; then
echo "SALTY_IDENTITY not set"
exit 2
fi
user="$1"
message="$2"
salty_json="$(mktemp /tmp/salty.XXXXXX)"
lookup "$user" > "$salty_json"
endpoint="$(jq -r '.endpoint' < "$salty_json")"
topic="$(jq -r '.topic' < "$salty_json")"
key="$(jq -r '.key' < "$salty_json")"
rm "$salty_json"
message="[$(date +%FT%TZ)] <$(get_user)> $message"
echo "$message" \
| salty -i "$SALTY_IDENTITY" -r "$key" \
| msgbus -u "$endpoint" pub "$topic"
}
make_user () {
mkdir -p "$HOME/.config/salty"
if [ $# -lt 1 ]; then
user=$USER
else
user=$1
fi
identity_file="$HOME/.config/salty/$user.key"
if [ -f "$identity_file" ]; then
printf "user key exists!"
exit 1
fi
# Check for msgbus env.. probably can make it fallback to looking for a config file?
if [ -z "$MSGBUS_URI" ]; then
printf "missing MSGBUS_URI in environment"
exit 1
fi
salty-keygen -o "$identity_file"
echo "# user: $user" >> "$identity_file"
pubkey=$(grep key: "$identity_file" | awk '{print $4}')
cat <<- EOF
Create this file in your webserver well-known folder. https://hostname.tld/.well-known/salty/$user.json
{
"endpoint": "$MSGBUS_URI",
"topic": "$user",
"key": "$pubkey"
}
EOF
}
# check if streaming
if [ ! -t 1 ]; then
stream
exit 0
fi
# Show Help
if [ $# -lt 1 ]; then
printf "Commands: send read lookup"
exit 0
fi
CMD=$1
shift
case $CMD in
send)
sendmsg "$@"
;;
read)
readmsgs "$@"
;;
lookup)
lookup "$@"
;;
make-user)
make_user "$@"
;;
esac
#!/bin/sh
# Validate environment
if ! command -v msgbus > /dev/null; then
printf "missing msgbus command. Use: go install git.mills.io/prologic/msgbus/cmd/msgbus@latest"
exit 1
fi
if ! command -v salty > /dev/null; then
printf "missing salty command. Use: go install go.mills.io/salty/cmd/salty@latest"
exit 1
fi
if ! command -v salty-keygen > /dev/null; then
printf "missing salty-keygen command. Use: go install go.mills.io/salty/cmd/salty-keygen@latest"
exit 1
fi
if [ -z "$SALTY_IDENTITY" ]; then
export SALTY_IDENTITY="$HOME/.config/salty/$USER.key"
fi
get_user () {
user=$(grep user: "$SALTY_IDENTITY" | awk '{print $3}')
if [ -z "$user" ]; then
user="$USER"
fi
echo "$user"
}
stream () {
if [ -z "$SALTY_IDENTITY" ]; then
echo "SALTY_IDENTITY not set"
exit 2
fi
jq -r '.payload' | base64 -d | salty -i "$SALTY_IDENTITY" -d
}
lookup () {
if [ $# -lt 1 ]; then
printf "Usage: %s nick@domain\n" "$(basename "$0")"
exit 1
fi
user="$1"
nick="$(echo "$user" | awk -F@ '{ print $1 }')"
domain="$(echo "$user" | awk -F@ '{ print $2 }')"
curl -qsSL "https://$domain/.well-known/salty/${nick}.json"
}
readmsgs () {
topic="$1"
if [ -z "$topic" ]; then
topic=$(get_user)
fi
export SALTY_IDENTITY="$HOME/.config/salty/$topic.key"
if [ ! -f "$SALTY_IDENTITY" ]; then
echo "identity file missing for user $topic" >&2
exit 1
fi
msgbus sub "$topic" "$0"
}
sendmsg () {
if [ $# -lt 2 ]; then
printf "Usage: %s nick@domain.tld <message>\n" "$(basename "$0")"
exit 0
fi
if [ -z "$SALTY_IDENTITY" ]; then
echo "SALTY_IDENTITY not set"
exit 2
fi
user="$1"
message="$2"
salty_json="$(mktemp /tmp/salty.XXXXXX)"
lookup "$user" > "$salty_json"
endpoint="$(jq -r '.endpoint' < "$salty_json")"
topic="$(jq -r '.topic' < "$salty_json")"
key="$(jq -r '.key' < "$salty_json")"
rm "$salty_json"
message="[$(date +%FT%TZ)] <$(get_user)> $message"
echo "$message" \
| salty -i "$SALTY_IDENTITY" -r "$key" \
| msgbus -u "$endpoint" pub "$topic"
}
make_user () {
mkdir -p "$HOME/.config/salty"
if [ $# -lt 1 ]; then
user=$USER
else
user=$1
fi
identity_file="$HOME/.config/salty/$user.key"
if [ -f "$identity_file" ]; then
printf "user key exists!"
exit 1
fi
# Check for msgbus env.. probably can make it fallback to looking for a config file?
if [ -z "$MSGBUS_URI" ]; then
printf "missing MSGBUS_URI in environment"
exit 1
fi
salty-keygen -o "$identity_file"
echo "# user: $user" >> "$identity_file"
pubkey=$(grep key: "$identity_file" | awk '{print $4}')
cat <<- EOF
Create this file in your webserver well-known folder. https://hostname.tld/.well-known/salty/$user.json
{
"endpoint": "$MSGBUS_URI",
"topic": "$user",
"key": "$pubkey"
}
EOF
}
# check if streaming
if [ ! -t 1 ]; then
stream
exit 0
fi
# Show Help
if [ $# -lt 1 ]; then
printf "Commands: send read lookup"
exit 0
fi
CMD=$1
shift
case $CMD in
send)
sendmsg "$@"
;;
read)
readmsgs "$@"
;;
lookup)
lookup "$@"
;;
make-user)
make_user "$@"
;;
esac
LuisMayo/spotify-ultrastar-downloader
Export Spotify playlists using the Web API
Language: JavaScript
Star: 1
Watch: 1 ⌘ Read more
Collecting Twitter data with TAGs and exporting to Gephi – Doug Specht
I’ve got to try this out on datasets I have collected with TAGS ⌘ Read more
How to export your complete Foursquare checkin history ⌘ Read more…
GitHub Artifact Exporter open source release ⌘ Read more…
one of the colony’s hottest exports, along with the “weirdest rocks we found” page of their wiki and the webcam onto their aquarium of mars microbes revived from lake sediments
some good initial progress with the !weewiki zettelkasten. messages can be made and tied to previous messages by providing partial UUIDs (that then get automatically expanded). basic export also works. #updates
How to Leave Google Photos | written by Robbie Antenesse ⌘ https://robbie.antenesse.net/2020/11/25/exporting-google-photos.html
I really really need to add page navigation to !worgle programs exported to !weewiki wiki pages.
The master plan is to export the !worgle bits of !monolith to a !weewiki, then begin adding user-level documentation that is able to dynamically reference bits of source code as another wiki page.
Posted to Entropy Arbitrage: Small Technology Notes https://john.colagioia.net/blog/2020/02/05/recutils.html #techtips #recutils #linux #sqlite #export
earth’s primary export turns out to be shadow, rare and sought-after in the sun’s plasma kingdoms as alchemical substance, weapon, drug